<template>
    <div>
        <div class="row mt-4">
            <div class="col-12">
                <FileUploader ref="uploader" accepted-file-types="text/plain" :maxFiles="1" :allow-multiple="false"
                    :addImagePreview="false" :addPdfPreview="false" />
            </div>
            <div class="col-12">
                <button type="button" class="btn btn-principal px-2" @click="procesarArchivo()">
                    Leer Archivo
                </button>
            </div>
        </div>
    </div>
</template>

<script setup lang="ts">
//librerias
import { ref, onMounted } from "vue";
import { loading, urlApi } from "@/shared.js";
import { FileUploader } from "@hcd-bsas/vue3-components";
import Swal from "sweetalert2/dist/sweetalert2.js";
import http from "@/http";
import router from "@/router";

const uploader = ref();

// onMounted(async () => {

//     loading.show();

//     loading.hide();
// });

async function procesarArchivo() {
    var files = uploader.value.getFiles();
    if (files.length == 0) {
        Swal.fire({
            icon: 'error',
            title: 'Error',
            text: "Agrege Un Archivo Para Procesar.",
        });
        return false;
    }

    var array_dni_cbu = "";
    var file = files[0].file;
    var nombre = file.name.substring(0, 8);
    if (nombre != 'ENTE974V') {
        Swal.fire({
            icon: 'error',
            title: 'Error',
            text: "Nombre de Archivo Incorrecto.",
        });
        return false;
    }
    loading.show();
    var dataText = await file.text();
    var lines = dataText.trim().split('\n');

    lines.forEach((line: string) => {
        let dni = line.substring(46, 54);
        let cbu = line.substring(133, 155);
        array_dni_cbu += dni + ";" + cbu + "|";
    });


    try {
        //hay que validar que el nombre no empiece con ENTE y que ademas , si el array no parseo nada, que tire error . (como validar el array por linea RARO)
        const response = await http.post(urlApi + "subirArchivoBapro", { archivo: file.name, array_dni_cbu: array_dni_cbu });

        if (response.status == 200 && response.data.status == "success") {
            Swal.fire({
                icon: 'success',
                title: 'Exito',
                text: "Archivo procesado con exito",
            });
            router.push({
                name: "inicioPedidosCuenta",
            })
        }
    } catch (error) {
        Swal.fire({
            icon: 'error',
            title: 'Error',
            text: "Ha ocurrido un error al procesar el archivo. ",
        });
        uploader.value.removeFile();
        loading.hide();
    }

    uploader.value.removeFile();
    loading.hide();
}



</script>
